#include <stdio.h>
#include <string.h>
#ifdef TCSUPPORT_SYSLOG_ENHANCE
#include <syslog.h>
#endif

#include "mini-asp.h"
#include "grammar.h"
#include "http-get-utils.h"
#include "../boa.h"
#include "../../../lib/libtcapi.h"

#if defined(TCSUPPORT_GENERAL_MULTILANGUAGE)
#include "parsers.h"
#endif

/*krammer add for bug 1321*/
#define WAN_PVC "Wan_PVC"
#define MAX_PVC_NUMBER 8
#define DEFAULT_RT_ATTR_LENGTH 4
#define DEFAULT_RT "DEFAULTROUTE"
#define TO_ASCII_OFFSET 48

static void get_post_multipart(request *req);
static void get_post(request *req);
static void get_query(request *req);
static int http_header();

void init_asp_funcs(void);
#ifndef TRENDCHIP
void init_asp_constants (void);
#endif
/*transfrom the number to ASCII*/
int decode_uri(char *uri);
static char hex_to_decimal(char char1,char char2);

static void asp_Write (asp_reent* reent, const asp_text* params,  asp_text* ret);
static void request_Form (asp_reent* reent, const asp_text* params,  asp_text* ret);
static void tcWebApi_Set (asp_reent* reent, const asp_text* params,  asp_text* ret);
static void tcWebApi_Get (asp_reent* reent, const asp_text* params,  asp_text* ret);
static void tcWebApi_Unset (asp_reent* reent, const asp_text* params,  asp_text* ret);
static void tcWebApi_Commit (asp_reent* reent, const asp_text* params,  asp_text* ret);
static void tcWebApi_Save (asp_reent* reent, const asp_text* params,  asp_text* ret);
static void tcWebApi_CurrentDefaultRoute(asp_reent * reent, const asp_text * params, asp_text * ret);
#if defined(TCSUPPORT_IMPROVE_GUI_PERFM)
static void tcWebApi_constSet (asp_reent* reent, const asp_text* params,  asp_text* ret);
#endif
static void tcWebApi_staticGet (asp_reent* reent, const asp_text* params,  asp_text* ret);
static void tcWebApi_CommitWithoutSave (asp_reent* reent, const asp_text* params,  asp_text* ret);
//aztech -felix.ian
#define MOUNT_INFO              "/proc/mounts"
#define USBDETECTION_FILE "/var/usbdetection"
#define STORAGE_INFO_FILE "/var/storage_info.txt"
#define PRINTER_INFO_FILE "/var/printer_info.txt"
#define KERNEL_PRINTER_FILE "/var/kernel_printer.txt"
#define DF_RESULT               "/var/df_result.txt"

char smbheader[128];//Aztech

#ifdef RA_PARENTALCONTROL
static void getClientMacAddr(char * ip_addr);
#endif/*RA_PARENTALCONTROL*/
#if defined(TCSUPPORT_WEBSERVER_SSL)
static request* temp_req = NULL;
#endif

int fd_out;
extern char cur_username[129];
#if defined(TCSUPPORT_WEB_SAVE)
extern int flag_save;
#endif

#if defined(TCSUPPORT_GENERAL_MULTILANGUAGE)
extern	int	getString(const char *pkey, char *value);
extern	int	initandparserfile(void);
extern	void	closefp(void);
extern	int	islangChanged(void);
#endif

static void az_sysInclude (asp_reent* reent, const asp_text* params,  asp_text* ret);
static void aztech_usbInfo(asp_reent* reent, const asp_text* params,  asp_text* ret);
static void aztech_umountusb(asp_reent* reent, const asp_text* params,  asp_text* ret);
static void StorageSubmit(asp_reent* reent, const asp_text* params,  asp_text* ret);
static void showPrinterInfor(asp_reent* reent, const asp_text* params,  asp_text* ret);
static void SiteSurvey(asp_reent* reent, const asp_text* params,  asp_text* ret);
static void EtherWanLine(void);


int asp_handler(request * req)
{
	int ret, i;
	char nodename[15], username[129];

	fprintf(stderr,"%s mothed:%d %s \n",__FUNCTION__,req->method,req->pathname);
	for(i = 0 ; i < 3; i++){
		sprintf(nodename, "Account_Entry%d", i);
		ret = tcapi_get(nodename, "username", username);
		if(ret < 0){ //Fail to acquire username from romfile
			fprintf(stderr, "Fail to acquire username from romfile: ret = %d\r\n", ret);
			return -1;
		}
		if(!strcmp(cur_username, username)){
			sprintf(nodename, "%d", i);
			ret = tcapi_set("WebCurSet_Entry", "CurrentAccess", nodename);
			if(ret < 0){ //Fail to set current username
				fprintf(stderr, "Fail to set current username: ret = %d\r\n", ret);
				return -1;
			}
			tcapi_get("WebCurSet_Entry", "CurrentAccess", username);
			break;
		}
	}
	if(i==3)
	{
		tcapi_set("WebCurSet_Entry", "CurrentAccess", "-1");
	}
	g_var_post = NULL;
#if defined(TCSUPPORT_WEBSERVER_SSL)
	temp_req = req;
	dontDoAsp = 0;
#endif
	fd_out = req->fd;
	if(http_header() == -1)
	{
		close(fd_out);
		req->status = DEAD;
		req->keepalive = KA_INACTIVE;//Ian_20070326
		return 0;//Ian_20070326
	}
	if((req->method == M_POST) && req->content_length){
		if(req->content_type == NULL)
		{
			get_post(req);
		}
		/*add support to parse multipart. shnwind 2009.4.8*/
		else if(strstr(req->content_type,"multipart") == NULL){
			get_post(req);
		}else{
			get_post_multipart(req);
		}
	}else if((req->method == M_GET) && req->query_string)
		get_query(req);

//	init_asp_funcs ();
//    init_asp_constants();
#ifdef RA_PARENTALCONTROL
	/* Modify for taking CGI environment to ASP handler by richard.lai */
	do_asp (req, req->pathname); 
#else
	do_asp (NULL, req->pathname);
#endif/*RA_PARENTALCONTROL*/
#if defined(TCSUPPORT_WEB_SAVE)
		if(flag_save == 1){
			flag_save = 0;
			
			tcapi_save();
		}
#endif
	#ifdef TRENDCHIP
	if(dontDoAsp !=0){
		dontDoAsp=0;
	}
	#endif
	free_param_line(g_var_post);
	req->cgi_status = CGI_DONE;
	req->status = DONE;
	close(fd_out);
	fprintf(stderr,"%s END \n",__FUNCTION__);
	req->keepalive = KA_INACTIVE;//Ian_20070326
	return 0;//Ian_20070326
}

static void get_post_multipart(request *req){

	//char boundary[64];
	char boundary[256]; 
	char *c_ret, *post;
	int fd, content_len;
	struct stat buf_st;
	int i, len_bound;


	/*get boundary*/
	c_ret = strstr(req->content_type,"boundary=");
	if(c_ret != NULL){
		len_bound = strlen(c_ret);
		if(len_bound <= sizeof(boundary)){
			for(i = strlen("boundary=") ; i < len_bound ;i++){
				/*do not need "-------"*/
				if(c_ret[i] != '-'){
					break;
				}
			}
			strcpy(boundary,c_ret+i);
			//tcdbg_printf("bound = %s\n",boundary);
		}else{
			tcdbg_printf("boundary too long!!!upgrade fail\n");
			return;
		}
	}
	/*paser all item information*/
	multipart_parser(req, boundary);
	/*get all item information*/
	if(stat(MULTI_TO_NORMAL_TEMP, &buf_st) != 0){
		return ;
	}
	content_len = buf_st.st_size;
	post = (char*)malloc(content_len+1);
	fd = open(MULTI_TO_NORMAL_TEMP,O_RDONLY);
	if(fd < 0){
		free(post);
		return;
	}
	if(read(fd,post,content_len) <= 0){
		free(post);
		close(fd);
		return;
	}
	close(fd);
	g_var_post = parse_param_line (post);
	free(post);
	//move to cfg_manager
	//unlink(MULTI_TO_NORMAL_TEMP);
}


static void get_post(request *req)
{
	char *post;
	int ret,len;

	len = atoi(req->content_length);
	post = (char*)malloc(len+1);
	memset(post,0,len+1);

	lseek(req->post_data_fd, 0,SEEK_SET);
	ret = read(req->post_data_fd,post,len);
	if(ret<=0)
		goto exit;

	//fprintf(stderr,"post:%s %s\n",post,req->content_length);
	g_var_post = parse_param_line (post);
exit:
	#if 0  //lee 2006-11-27
	close(req->post_data_fd);
	req->post_data_fd = 0;
	#endif
	free(post);
}

static void get_query(request *req)
{
#if 0
	char *query;
	int len;

	len = strlen(req->query_string);
	query =(char*) malloc(len+1);
	memcpy(query,req->query_string,len);
	//fprintf(stderr,"query:%s %d\n",query,len);
	g_var_post = parse_param_line (query);
	free(query);
#endif
	g_var_post = parse_param_line (req->query_string);
}

static int http_header()
{
	char HTTP_OK[] = "HTTP/1.0 200 OK\r\n";
/*pork 20090309 added*/
#if 0
	char CONTENT_TYPE[] = "Content-type: text/html;charset=GB2312\r\n\r\n";
#else
	char CONTENT_TYPE[64];
	if(charset){
		sprintf(CONTENT_TYPE,"Content-type: text/html;charset=%s\r\n\r\n",charset);
	}
	else{
		/*default char set: ISO-8859-1*/
		sprintf(CONTENT_TYPE,"Content-type: text/html;charset=ISO-8859-1\r\n\r\n");
	}
#endif
/*pork 20090309 added over*/

	if(asp_send_response (NULL, HTTP_OK, strlen(HTTP_OK)) == -1)
		return -1;

	if(asp_send_response (NULL, CONTENT_TYPE, strlen(CONTENT_TYPE)) ==-1)
		return -1;

	return 0;
}
static void
PPPoEDisConnect(asp_reent* reent, const asp_text* params,  asp_text* ret)
{

   system("/usr/script/wan_stop.sh 0 0");
}
#ifndef TRENDCHIP
static void Request_Form(asp_reent* reent, int id, const asp_text* params,  asp_text* ret)
{
	char *val,*tmp;

	//fprintf(stderr, "(%s ID: %d ", __FUNCTION__, id);
    ret->str ="";
    ret->len = 0;
    if (params->str && params->len)
    {
    	//fwrite(params->str, params->len, 1, stderr);

    	tmp = (char*)asp_alloc(reent,params->len+1);
    	memset(tmp,0,params->len+1);
    	memcpy(tmp,params->str,params->len);
    	val = get_param(g_var_post,tmp);
    	if(val ==NULL)
    		return;

		ret->str = val;
		ret->len = strlen(val);
    }
    //else
    //	fprintf (stderr, "No Params )");
    //fprintf (stderr, "\n");

}

extern asp_reent *my_reent;
static void TcWebApi_set (asp_reent* reent, int id, const asp_text* params,  asp_text* ret)
{
	char *tmp;

    //fprintf(stderr, "(%s ID: %d ", __FUNCTION__, id);
    if (params->str && params->len)
    {
      //fwrite(params->str, params->len, 1, stderr);

      tmp = (char*)asp_alloc(reent,params->len+1);
      memset(tmp,0,params->len+1);
      memcpy(tmp,params->str,params->len);
      my_reent = reent;
      asp_TCWebApi_set(id,tmp);
    }
    //else
    //	fprintf (stderr, "No Params )");
    //fprintf (stderr, "\n");

}


static void TcWebApi_get (asp_reent* reent, int id, const asp_text* params,  asp_text* ret)
{
	char *val;

	#if 0
    fprintf(stderr, "(%s ID: %d ", __FUNCTION__, id);

    if (params->str && params->len)
      fwrite(params->str, params->len, 1, stderr);
    else
      fprintf (stderr, "No Params )");
    fprintf (stderr, "\n");
    #endif

    my_reent = reent;
    val = asp_TCWebApi_get(id);
    if(val == NULL)
    {
    	ret->str = "";
    	ret->len = 0;
    }
    else
    {
    	ret->str = val;
		ret->len = strlen(val);
    }

}

static void TcWebApi_execute (asp_reent* reent, int id, const asp_text* params,  asp_text* ret)
{

    //fprintf(stderr, "%s ID: %d \n", __FUNCTION__, id);
    my_reent = reent;
    asp_TCWebApi_execute(id);
}
#endif
void init_asp_funcs(void)
{
    #ifndef TRENDCHIP
    append_asp_func ("Request.Form", Request_Form);
    append_asp_func ("TcWebApi_set", TcWebApi_set);
    append_asp_func ("TcWebApi_get", TcWebApi_get);
    append_asp_func ("TcWebApi_execute", TcWebApi_execute);
    #else
    /*new tcWebApi*/
    append_asp_func ("asp_Write", asp_Write);
    append_asp_func ("request_Form", request_Form);
    append_asp_func ("tcWebApi_Set", tcWebApi_Set);
    append_asp_func ("tcWebApi_Get", tcWebApi_Get);
    append_asp_func ("tcWebApi_Unset", tcWebApi_Unset);
    append_asp_func ("tcWebApi_Commit", tcWebApi_Commit);
    append_asp_func ("tcWebApi_Save", tcWebApi_Save);
	append_asp_func ("sysInclude", az_sysInclude);
        append_asp_func ("showUsbInfo", aztech_usbInfo);
        append_asp_func ("umountusb", aztech_umountusb);
        append_asp_func ("StorageSubmit", StorageSubmit);
        append_asp_func ("showPrinterInfor", showPrinterInfor);
/*krammer add for bug 1321*/
    append_asp_func("tcWebApi_CurrentDefaultRoute", tcWebApi_CurrentDefaultRoute);
#if defined(TCSUPPORT_IMPROVE_GUI_PERFM)
    append_asp_func ("tcWebApi_constSet", tcWebApi_constSet);
#endif
    append_asp_func ("tcWebApi_staticGet", tcWebApi_staticGet);

    append_asp_func ("tcWebApi_CommitWithoutSave", tcWebApi_CommitWithoutSave);
	 append_asp_func ("PPPoEDisConnect", PPPoEDisConnect);

	append_asp_func ("SiteSurvey", SiteSurvey);

	append_asp_func ("EtherWanLine", EtherWanLine); //Added by Jane Jiang 20151030
	
    #endif
}

static void wait_fd (int fd)
{
	fd_set block_write_fdset,block_read_fdset;
	#ifdef TRENDCHIP
	struct timeval timeout={FAIL_SESSION_TIMEOUT,0};
	int ret=0;
	#endif

	while (1)
	{
		FD_ZERO(&block_write_fdset);
		FD_SET (fd, &block_write_fdset);
		FD_ZERO(&block_read_fdset);
		FD_SET (fd, &block_read_fdset);
	 	#ifdef TRENDCHIP
                /*
                   krammer change for bug 1094
                   we make select to have a timeout, if timeout, that means the session has some
                   thing wrong, so we break wait fd and dont do any asp until new session.
                */
            	if ((ret=select(fd + 1, &block_read_fdset,
                   &block_write_fdset, NULL,
                   &timeout)) <0 ) {
		#else
		if (select(fd + 1, &block_read_fdset,
                   &block_write_fdset, NULL,
                   0) <=0 ) {
              #endif
            /* what is the appropriate thing to do here on EBADF */
            if (errno == EINTR)
            {
                continue;   /* while(1) */
            }
            else if (errno != EBADF) {
                fprintf(stderr,"select error \n");
            }
        }
		#ifdef TRENDCHIP
		if(ret==0){/*timeout*/
			dontDoAsp=1;
			break;
		}
		#endif
		if (FD_ISSET(fd, &block_read_fdset))
			break;

		if (FD_ISSET(fd, &block_write_fdset))
			break;
	}

}


int asp_send_response (asp_reent* reent, const void* buffer, size_t len)
{

	int res=0;
	#ifdef TRENDCHIP
	 /*
           krammer add for bug 1094, this flag can block asp_send_response when
           wait_fd is timeout and change_ip flag is set.
        */
	if(dontDoAsp){
		return 0;
	}
	#endif

loop_write:

	len =len-res;
	buffer = buffer+res;

	wait_fd (fd_out);
#if defined(TCSUPPORT_WEBSERVER_SSL)
	if(temp_req->ssl == NULL)
#endif
	{
	res = write(fd_out,buffer,len);
	}
#if defined(TCSUPPORT_WEBSERVER_SSL)
	else{
		int retCode = 0; 
		if(len <=0)
			return 0; 
		res = boa_sslWrite(temp_req->ssl, buffer,len,&retCode);
		if(res<0)
		{
			dontDoAsp = 1;
		}
	}
#endif

  if(res <0 )
  {
  	return -1;
  }
  if(res<len)
  	goto loop_write;

  return 0;



}
#ifndef TRENDCHIP
void init_asp_constants (void)
{
  //sample append_asp_constant ("WAN_SETTING",					0);

}
#endif
#ifdef TRENDCHIP
/*____________________________________________________________________*
**	function name: asp_Write
**
**	description:
*     Output the string to web page.
*
**	parameters:
*     reent:not use
*     id:not use
*     params:params[0] will save the string user input
*     ret:not use
**	global:
*     none
**	return:
*     0:successful
*     -1:fail
**	call:
*     none
**	revision:
*     1.shnwind
* _______________________________________________________________*/

static void
asp_Write (asp_reent* reent, const asp_text* params,  asp_text* ret)
{

    asp_send_response (NULL,params[0].str,params[0].len);

}
/*____________________________________________________________________*
**	function name: request_Form
**
**	description:
*     get the value of item on page.
*
**	parameters:
*     reent:not use
*     id:not use
*     params:params[0] item name.
*     ret:not use
*
**	global:
*     none
**	return:
*     none
**	call:
*     none
**	revision:
*     1.shnwind
* _____________________________________________________________________*/
static void
request_Form (asp_reent* reent, const asp_text* params,  asp_text* ret)
{

    char *val,*tmp;

    /*ret->str = "");
    ret->len = 0;*/

    if (params[0].str && params[0].len)
    {
    	tmp = (char*)asp_alloc(reent,params[0].len+1);
    	memset(tmp,0,params[0].len+1);
    	memcpy(tmp,params[0].str,params[0].len);
    	val = get_param(g_var_post,tmp);

	//tcdbg_printf("request name %s value %s\n",tmp,val);
      if(val ==NULL)
    		return;
		decode_uri(val);
		ret->str = val;
		ret->len = strlen(val);
    }

}

/*____________________________________________________________________*
**	function name: tcWebApi _set
**
**	description:
*     write the value which is user input to cfg_manager.
*
**	parameters:
*     reent:not use
*     id:not use
*     params:params[0] node name.
*            params[1] attribute name.
*            params[2] value
*     ret:not use
*
**	global:
*     none
**	return:
*     none
**	call:
*     none
**	revision:
*     1.shnwind
* _____________________________________________________________________*/
static void
tcWebApi_Set (asp_reent* reent, const asp_text* params,  asp_text* ret)
{

    char *node,*attr,*value,*v_tmp;
    int r_val, i = 0;
	char *directSet[] = {"CurPage", ""};

    node = (char*)asp_alloc(reent,params[0].len+1);
    attr = (char*)asp_alloc(reent,params[1].len+1);
    value = (char*)asp_alloc(reent,params[2].len+1);
    memset(node,0,params[0].len+1);
    memset(attr,0,params[1].len+1);
    memset(value,0,params[2].len+1);
    memcpy(node,params[0].str,params[0].len);
    memcpy(attr,params[1].str,params[1].len);
    memcpy(value,params[2].str,params[2].len);
    node[params[0].len]='\0';
    attr[params[1].len]='\0';
    value[params[2].len]='\0';

    if(params[2].len == 0){
      return;
    }

    v_tmp = get_param(g_var_post,value);//get_param on web page
    //tcdbg_printf("set node = %s attr %s value %s\n",node,attr,v_tmp);
    if(v_tmp != NULL){
      decode_uri(v_tmp);
      r_val=tcapi_set(node, attr,v_tmp);
    }
	else{//If the value is not the name of an attribute, regard it as the value to be assigned
		while(strlen(directSet[i]))
			if(!strcmp(attr, directSet[i++]))
				r_val=tcapi_set(node, attr, value);
	}
		

}
void strQuotConvertHTML(char *oriStr,char *desStr)  {
    int i;
    int j = 0;
    for(i = 0;i < strlen(oriStr);i++){
    	if(oriStr[i] == '"'){
    		strcpy(&(desStr[j]),"&quot;");
    		j+=6;
    	}
    	else{
    		desStr[j] = oriStr[i];
    		j++;
    	}
    }
    desStr[j] = '\0';
}
/*____________________________________________________________________*
**	function name: tcWebApi _get
**
**	description:
*     get the attribute value of specific node.
*
**	parameters:
*     reent:not use
*     id:not use
*     params:params[0] node name.
*            params[1] attribute name.
*            params[2] show or hide
*     ret:if params[2] == hide, use ret to return value.
*         if params[2] == show, use asp_send_response() to output string on page.
*
**	global:
*     none
**	return:
*     none
**	call:
*     none
**	revision:
*     1.shnwind
* _____________________________________________________________________*/
static void
tcWebApi_Get (asp_reent* reent, const asp_text* params,  asp_text* ret)
{
#if !defined(TCSUPPORT_CT) 
#if defined(TCSUPPORT_GUI_STRING_CONFIG) || defined(TCSUPPORT_GENERAL_MULTILANGUAGE)
#if defined(TCSUPPORT_GENERAL_MULTILANGUAGE)
	static char val[MAX_VALUE];
#else
	static char val[580];
#endif
#endif
	char *node,*attr,*show;
#if defined(TCSUPPORT_GUI_STRING_CONFIG) || defined(TCSUPPORT_GENERAL_MULTILANGUAGE)
#if defined(TCSUPPORT_GENERAL_MULTILANGUAGE)
	static char retVal[MAX_STREAM];
#else
	char retVal[640];
#endif
#endif
	int r_val;

	node = (char*)asp_alloc(reent,params[0].len+1);
	attr = (char*)asp_alloc(reent,params[1].len+1);
	show = (char*)asp_alloc(reent,params[2].len+1);
	memset(node,0,params[0].len+1);
	memset(attr,0,params[1].len+1);
	memset(show,0,params[2].len+1);
	memcpy(node,params[0].str,params[0].len);
	memcpy(attr,params[1].str,params[1].len);
	memcpy(show,params[2].str,params[2].len);
	node[params[0].len]='\0';
	attr[params[1].len]='\0';
	show[params[2].len]='\0';
#ifdef RA_PARENTALCONTROL
	if(strcmp(node, "Parental") == 0 && strcmp(attr, "BrowserMAC") == 0){
		getClientMacAddr(reent->server_env->remote_ip_addr);
	} else {
#endif/*RA_PARENTALCONTROL*/

#if defined(TCSUPPORT_GENERAL_MULTILANGUAGE)
		if (!strcmp(node, "String_Entry"))
		{
			if(0 == getString(attr, val))
				strcpy(val, "N/A");
		}
		else {
#endif
		r_val = tcapi_get(node, attr, val);
		if(r_val < 0){
			strcpy(val,"N/A");
		}
#if defined(TCSUPPORT_GENERAL_MULTILANGUAGE)
		}
#endif
		if(!strcmp(show,"s")){//show -> s
#if defined(TCSUPPORT_GUI_STRING_CONFIG) || defined(TCSUPPORT_GENERAL_MULTILANGUAGE)
	if(strcmp(node,"String_Entry"))          //not from String_Entry
    	{    		
    		strQuotConvertHTML(val,retVal);
    	}
	else
	{
		memset(retVal,0,572);
		strcpy(retVal,val);
	}
#endif
			asp_send_response (NULL,retVal,strlen(retVal));
		}
		else if(!strcmp(show,"h")){//hide -> h
			if(strlen(val))
				ret->str = val;
			ret->len = strlen(val);
		}
#ifdef RA_PARENTALCONTROL
	}
#endif/*RA_PARENTALCONTROL*/
#endif
}
/*_____________________________________________________________________________*
**	function name: tcWebApi _unset
**
**	description:
*     delete the all attribute value of specific node.
*
**	parameters:
*     reent:not use
*     id:not use
*     params:params[0] node name.
*     ret:not use
*
**	global:
*     none
**	return:
*     0:successful
*     -1:fail
**	call:
*     none
**	revision:
*     1.shnwind
* ___________________________________________________________________________*/

static void
tcWebApi_Unset (asp_reent* reent, const asp_text* params,  asp_text* ret)
{

    char *node;
    int r_val;

    node = (char*)asp_alloc(reent,params[0].len+1);
    memset(node,0,params[0].len+1);
    memcpy(node,params[0].str,params[0].len);

    r_val=tcapi_unset(node);

}
/*___________________________________________________________________*
**	function name: tcWebApi_commit
**
**	description:
*     Write the value of specific attribute to file system.
*
**	parameters:
*     reent:not use
*     id:not use
*     params:params[0] node name.
*     ret:not use
*
**	global:
*     none
**	return:
*     0:successful
*     -1:fail
**	call:
*     none
**	revision:
*     1.shnwind
* __________________________________________________________________*/

static void
tcWebApi_Commit (asp_reent* reent, const asp_text* params,  asp_text* ret)
{
	  char *node;
    int r_val;
 #if defined(TCSUPPORT_WEB_SAVE)
    char bootType[16] = {0};
 #endif

    node = (char*)asp_alloc(reent,params[0].len+1);
    memset(node,0,params[0].len+1);
    memcpy(node,params[0].str,params[0].len);

#if defined(TCSUPPORT_WAN_ATM) || defined(TCSUPPORT_WAN_PTM) || defined(TCSUPPORT_WAN_ETHER)
//when someone uses webpage to commit wan, let CC have one more chance to do WAN_STOP or WAN_START for ATM/PTM.
	if(strstr(node,"Wan_PVC")){
		system("echo 1 > /tmp/commitByWeb");
	}
#endif

    r_val=tcapi_commit(node);
    //tcdbg_printf("commit ret = %d node %s\n",r_val,node);

#if defined(TCSUPPORT_GENERAL_MULTILANGUAGE)
	if (!strcmp(node, "LanguageSwitch_Entry"))
	{
		if (1 == islangChanged()) {
			initandparserfile();
		}
	}
#endif

#if defined(TCSUPPORT_WEB_SAVE)
    flag_save = 1;
    if(strcmp(node, SYSTEM_NODE) == 0) {
	tcapi_get(SYSTEM_NODE, REBOOT_TYPE, bootType);
	if(atoi(bootType) != NO_BOOT)
	     flag_save = 0;//If do system reboot or reset default, should not do save
    }
#endif

#ifdef TCSUPPORT_SYSLOG_ENHANCE
   	openlog("TCSysLog WEB", 0, LOG_LOCAL1);
   	syslog(LOG_INFO, "Configuration changed\n");
	closelog();
#endif
}

static void
tcWebApi_CommitWithoutSave (asp_reent* reent, const asp_text* params,  asp_text* ret)
{
	  char *node;
    int r_val;

    node = (char*)asp_alloc(reent,params[0].len+1);
    memset(node,0,params[0].len+1);
    memcpy(node,params[0].str,params[0].len);

    r_val=tcapi_commit(node);
    //tcdbg_printf("commit ret = %d node %s\n",r_val,node);

}

/*____________________________________________________________________*
**	function name: tcWebApi _save
**
**	description:
*     Write all system parameters to flash
*
**	parameters:
*     reent:not use
*     id:not use
*     params:not use
*     ret:not use
*
**	global:
*     none
**	return:
*     none
**	call:
*     none
**	revision:
*     1.shnwind
* _____________________________________________________________________*/

static void
tcWebApi_Save (asp_reent* reent, const asp_text* params,  asp_text* ret)
{
#if defined(TCSUPPORT_WEB_SAVE)
	flag_save = 0;
#endif
    tcapi_save();
}

static char
hex_to_decimal(char char1,char char2)
{
	return (((char1 >= 'A') ? (((char1 & 0xdf) - 'A') + 10) : (char1 - '0')) * 16) + (((char2 >= 'A') ? (((char2 & 0xdf) - 'A') + 10) : (char2 - '0')));
}

int
decode_uri(char *uri)
{
	char c, d;
  char *uri_old;
  int count = 0;

  uri_old = uri;
  while ((c = *uri_old)) {
    if(count++ == 128){/*max run 128 cycle*/
      return 0;
    }
    if (c == '%') {
        uri_old++;
        if ((c = *uri_old++) && (d = *uri_old++))
          *uri++ = hex_to_decimal(c, d);
        else
          return 0;       /* NULL in chars to be decoded */
    }else{
			*uri++ = c;
      uri_old++;
    }
  }
  *uri = '\0';
  return 1;
}

/*krammer add for bug 1321*/
/*____________________________________________________________________*
**	function name: tcWebApi_CurrentDefaultRoute
**
**	description:
*     get the current route pvc number
*
**	parameters:
*     reent:not use
*     id:not use
*     params:not use
*     ret:not use
*
**	global:
*     none
**	return:
*     current default route pvc number
**	call:tcapi_get, asp_send_response
*     none
**	revision:
*     1.krammer
* _____________________________________________________________________*/

static void
tcWebApi_CurrentDefaultRoute(asp_reent* reent, const asp_text* params,  asp_text* ret)
{
	char i, defaultRT;
	int r_val;
	char val[DEFAULT_RT_ATTR_LENGTH]={0};
	char wanPvc[16]={0};

	for(i=0; i<MAX_PVC_NUMBER; i++){
		sprintf(wanPvc,"%s%d",WAN_PVC,i);
		r_val=tcapi_get(wanPvc, DEFAULT_RT, val);
		if(r_val<0){
			continue;
		}
		if(!strcmp(val, "Yes")){
			defaultRT=i+TO_ASCII_OFFSET;
			asp_send_response (NULL,&defaultRT,1);
			return;
		}
	}
	/*can't fine default route, we use pvc 0 to be the default route*/
	defaultRT=0+TO_ASCII_OFFSET;
	asp_send_response (NULL,&defaultRT,1);
}

#endif

#if defined(TCSUPPORT_IMPROVE_GUI_PERFM)
/*____________________________________________________________________*
**      function name: tcWebApi_constSet
**
**      description:
*     write the const value which is user input to cfg_manager.
*
**      parameters:
*     reent:not use
*     id:not use
*     params:params[0] node name.
*            params[1] attribute name.
*            params[2] value
*     ret:not use
*
**      global:
*     none
**      return:
*     none
**      call:
*     none
**      revision:
*     1.shnwind
* _____________________________________________________________________*/
static void
tcWebApi_constSet (asp_reent* reent, const asp_text* params,  asp_text* ret)
{
        char *node,*attr,*value;
        int r_val;
        
        node = (char*)asp_alloc(reent,params[0].len+1);
        attr = (char*)asp_alloc(reent,params[1].len+1);
        value = (char*)asp_alloc(reent,params[2].len+1);
        memset(node,0,params[0].len+1);
        memset(attr,0,params[1].len+1);
        memset(value,0,params[2].len+1);
        memcpy(node,params[0].str,params[0].len);
        memcpy(attr,params[1].str,params[1].len);
        memcpy(value,params[2].str,params[2].len);
        node[params[0].len]='\0';
        attr[params[1].len]='\0';
        value[params[2].len]='\0';

        // can alow set NULL
	/*
        if(params[2].len == 0)
        {
                return;
        }
	*/
        
        r_val=tcapi_set(node, attr, value);
}
#endif
/*____________________________________________________________________*
**      function name: tcWebApi_staticGet
**
**      description:
*     get the attribute value of specific node.
*
**      parameters:
*     reent:not use
*     id:not use
*     params:params[0] node name.
*            params[1] attribute name.
*            params[2] show or hide
*     ret:if params[2] == hide, use ret to return value.
*         if params[2] == show, use asp_send_response() to output string on page.
*
**      global:
*     none
**      return:
*     none
**      call:
*     none
**      revision:
*     1.shnwind
* _____________________________________________________________________*/
static void
tcWebApi_staticGet (asp_reent* reent, const asp_text* params,  asp_text* ret)
{
        static char val[129];
        char *node,*attr,*show;
        char retVal[129];
        int r_val;
        
        node = (char*)asp_alloc(reent,params[0].len+1);
        attr = (char*)asp_alloc(reent,params[1].len+1);
        show = (char*)asp_alloc(reent,params[2].len+1);
        memset(node,0,params[0].len+1);
        memset(attr,0,params[1].len+1);
        memset(show,0,params[2].len+1);
        memcpy(node,params[0].str,params[0].len);
        memcpy(attr,params[1].str,params[1].len);
        memcpy(show,params[2].str,params[2].len);
        node[params[0].len]='\0';
        attr[params[1].len]='\0';
        show[params[2].len]='\0';
        r_val = tcapi_staticGet(node, attr, val);
        if(r_val < 0)
        {
                strcpy(val,"N/A");
        }
        
        //show -> s
        if(!strcmp(show,"s"))
        {
                strQuotConvertHTML(val,retVal);
                asp_send_response (NULL,retVal,strlen(retVal));
        }
        //hide -> h
        else if(!strcmp(show,"h"))
        {
                if(strlen(val))
                        ret->str = val;
                ret->len = strlen(val);
        }

}


#ifdef RA_PARENTALCONTROL
/* Add for Time Restrict by richard.lai */
/*____________________________________________________________________*
**	function name: getClientMacAddr
**
**	description:
*     Get Client Mac Address.
*
**	parameters:
*     reent:not use
*     id:not use
*     params:not use
*     ret:not use
*
**	global:
*     none
**	return:
*     none
**	call:
*     none
**	revision:
*     1.shnwind
* _____________________________________________________________________*/
#define PROC_ARP "/proc/net/arp"
static void
getClientMacAddr (char * ip_addr) {

	static char val[129];
	char retVal[129];
	FILE *fp;
	char buf[80];
	char ipaddr[16], hwtype[16], flags[16], hwaddr[20], mask[16], device[16], state[16];

	fp = fopen(PROC_ARP, "r");
	if(fp) {
		while(fgets(buf, 80, fp)){
		if(sscanf(buf, "%s %s %s %s %s %s %s\n", ipaddr, hwtype, flags, hwaddr, mask, device, state) > 3) {
			if(strcmp(ipaddr, ip_addr) == 0) {
				strcpy(val, hwaddr);
				strQuotConvertHTML(val, retVal);
				asp_send_response (NULL, retVal, strlen(retVal));
				break;
			}
		}
		}
		fclose(fp);
	}
}
#endif/*RA_PARENTALCONTROL*/

static void
az_sysInclude(asp_reent* reent, const asp_text* params,  asp_text* ret)
{
    char *val,*tmp;

    if (params[0].str && params[0].len)
    {
		tmp = (char*)asp_alloc(reent,params[0].len+1);
		memset(tmp,0,params[0].len+1);
		memcpy(tmp,params[0].str,params[0].len);

	FILE *fp;
	char ptr[256] = {0};
	int line_size=256;
        sprintf(ptr, "/boaroot/cgi-bin/%s",tmp);
	

	#if 0
	if(!strcmp(tmp, "header.asp")) {
		fp=fopen("/boaroot/cgi-bin/header.asp","r");
	}
	else if(!strcmp(tmp, "header_adv.asp")) {
		fp=fopen("/boaroot/cgi-bin/header_adv.asp","r");
	}
	else if(!strcmp(tmp, "top.asp")) {
		fp=fopen("/boaroot/cgi-bin/top.asp","r");
	}
	else if(!strcmp(tmp, "top_adv.asp")) {
		fp=fopen("/boaroot/cgi-bin/top_adv.asp","r");
	}

	if (fp == NULL)
	{
		return;
	}

	while(fgets(ptr, line_size, fp))
	{
			asp_send_response (NULL, ptr, strlen(ptr));
	}

	fclose(fp);
		fclose(fp);

	#else

	do_asp(NULL,ptr);

	#endif
    }

}
#define DBPRINT(x...) { \
FILE *fp = fopen("/dev/console", "w"); \
if (fp) { \
fprintf(fp, x); \
fclose(fp); \
} \
}

static void showPrinterInfor(asp_reent* reent, const asp_text* params,  asp_text* ret) {
    FILE *fd = NULL;
    int MAX_BUF_SZ = 256;
	int r_val;
    char serial[MAX_BUF_SZ], manufacturer[MAX_BUF_SZ], totalbuf[MAX_BUF_SZ*4], lanip[32];
    fd = fopen(KERNEL_PRINTER_FILE, "r");
	memset(serial, 0,MAX_BUF_SZ );
	memset(manufacturer, 0,MAX_BUF_SZ );
	memset(totalbuf, 0,MAX_BUF_SZ*4 );
	

    if (fd) {
       	fgets(serial,MAX_BUF_SZ-1, fd);
		serial[strlen(serial)-1] = '\0';
		fgets(manufacturer,MAX_BUF_SZ-1, fd);
		r_val = tcapi_get("Lan_Entry0", "IP", lanip);
	    if(r_val < 0){
	      strcpy(lanip,"N/A");
	    }
		sprintf(totalbuf,"{printers:[{serial:'%s',manufacturer:'%s',ipaddress:'%s',port:'9100'}]}",serial,manufacturer,lanip);
        fclose(fd);
    }else
    {
    	strcpy(totalbuf, "{printers:[]}");
    }
    asp_send_response (NULL, totalbuf, strlen(totalbuf));
}



static void aztech_usbInfo(asp_reent* reent, const asp_text* params,  asp_text* ret)
{
	FILE *fd;
	int MAX_BUF_SZ = 4096;
    char buf[MAX_BUF_SZ];
	buf[0] = 0;
    fd = fopen(STORAGE_INFO_FILE, "r");
	
    if (fd) 
	{
        if (fgets(buf, MAX_BUF_SZ-1, fd) != NULL) 
		{
            if (buf[0] == '\0') 
			{
              strcpy(buf, "{devices:[]}");
            } 
        }
        fclose(fd);
    }
	else
	{
        strcpy(buf, "{devices:[]}");
    }

	asp_send_response (NULL, buf, strlen(buf));
}

static void aztech_umountusb(asp_reent* reent, const asp_text* params,  asp_text* ret)
{
	char pathnum[9 + 1];
    char *tmppath;
    int totalcount = 0, i = 0;
	char cmd_str[254];
	FILE *fp_unmount = NULL;
	char myoutput[256];
	int umount_result = 0;
	char *tmp;

	memset(pathnum, 0, sizeof(pathnum));
	memset(cmd_str, 0, sizeof(cmd_str));

	tmp = get_param(g_var_post,"totalcount");

	if(tmp)
		totalcount = atoi(tmp);
	
	for (i = 0; i < totalcount; i++)
	{

		 sprintf(pathnum, "path%d", i); 
		 tmppath = get_param(g_var_post,pathnum);

		 if(!tmppath)
			continue;
		 
		 decode_uri(tmppath);
		sprintf(cmd_str, "%s%s  2>/var/umount.log ", "umount ",tmppath);
		printf("cmd_str is %s\n",cmd_str);
		system(cmd_str);

		// check if umount error = stdout 2
		fp_unmount = fopen("/var/umount.log", "r");
		if(NULL != fp_unmount)
		{
			memset(myoutput, 0, sizeof(myoutput));
			if(fgets(myoutput, sizeof(myoutput)-1, fp_unmount) != NULL)
			{
				printf("my out put is %s\n",myoutput);
				//judge if the device is busy
				if(strstr(myoutput, "busy") != NULL)
				{
					printf("can't forcibly umount :Device or resource busy\n");
					umount_result = 1;
				}
			}
		}

		if(fp_unmount)
			fclose(fp_unmount);

		 memset(pathnum, 0, sizeof(pathnum));
		memset(cmd_str, 0, sizeof(cmd_str));
	}
	if(umount_result)
	{
		asp_send_response (NULL, "{success:false,error:1}", 23);
	}else
	{
		asp_send_response (NULL, "{success:true}", 14);
	}

	//system("echo 1 > /var/usbdetection");
	
}

static int launchSambaSrv(void) {
    int i;
    FILE *fp_proc = NULL;
    FILE *fp_smbconfig = NULL;
    char smb_config_file[30];
    char part[64], path[64], dev_type[64], buf[64];
    // A /media/sda1 no no
    char smbname[64], smbpath[64], smbshare[64], smbaccess[64];
    char cmd_str[128];

    memset(cmd_str, 0, sizeof(cmd_str));

	memset(part, 0, sizeof(part));
    memset(path, 0, sizeof(path));
    memset(dev_type, 0, sizeof(dev_type));
 
	 // config file 
	memset(smbheader, 0, sizeof(smbheader));
	memset(smbname, 0, sizeof(smbname));
	memset(smbpath, 0, sizeof(smbpath));
	memset(smbshare, 0, sizeof(smbshare));
	memset(smbaccess, 0, sizeof(smbaccess));

    // this will killall samba
	system("/usr/script/storage.sh samba");
	
    // open proc file to fetch related config file in /media/sda1, 2 /sdb1,2

    fp_proc = fopen(MOUNT_INFO, "r");
    if (NULL == fp_proc)
	{

        return -1;
    }

    while (EOF != fscanf(fp_proc, "%s %s %s %*s %*s %*s\n", part, path, dev_type)) 
	{
        //1: Get Partition Volume Type
        if (0 != strncmp(path, "/tmp/mnt/usb", 12)) 
		{
            continue;
        }

        // search /media/sda 1,2,3  line by line  /proc/mounts
        sprintf(smb_config_file, "%s/smb_config", path);
		//DBPRINT("%s %d smb_config is %s \n",__FUNCTION__, __LINE__, smb_config_file);
		
		
        if (NULL == (fp_smbconfig = fopen(smb_config_file, "r")))
		{

           
			//DBPRINT("%s %d Error Opening: %s \n",__FUNCTION__, __LINE__, smb_config_file);
			if(fp_proc)
				fclose(fp_proc);
            return -1;
        }

		// line 0 "Aztech" 
		memset(buf, 0, sizeof(buf));
		memset(smbheader, 0, sizeof(smbheader));
		if(fgets(buf, sizeof(buf)-1, fp_smbconfig) != NULL)
		{
			//azt_printf("buf is %s\n", buf);
			//azt_printf("buf len0 is %d\n",strlen(buf));
			buf[strlen(buf)-1] = 0;
			strcpy(smbheader,buf);
			//azt_printf("buf len00 is %d\n",strlen(buf));
			//azt_printf("smbheader is %s\n",smbheader);
			//azt_printf("smbheader len is %d\n",strlen(smbheader));
		}
        // line 1 smbname A/B/C
        memset(buf, 0, sizeof(buf));
		memset(smbname, 0, sizeof(smbname));
        if (fgets(buf, sizeof(buf)-1, fp_smbconfig) != NULL)
		{
            buf[strlen(buf) - 1] = 0; 
            strcpy(smbname, buf);
        }
        //line 2 /media/sda1 sda2
        memset(buf, 0, sizeof(buf));
		memset(smbpath, 0, sizeof(smbpath));
        if (fgets(buf, sizeof(buf)-1, fp_smbconfig) != NULL)
		{
            buf[strlen(buf) - 1] = 0;
            strcpy(smbpath, buf);
        }
        // line3 no
        memset(buf, 0, sizeof(buf));
		memset(smbshare, 0, sizeof(smbshare));
        if (fgets(buf, sizeof(buf)-1, fp_smbconfig) != NULL) 
		{
            buf[strlen(buf) - 1] = 0;
            strcpy(smbshare, buf);
        }
        //line 4 no
        memset(buf, 0, sizeof(buf));
		memset(smbaccess, 0, sizeof(smbaccess));
        if (fgets(buf, sizeof(buf)-1, fp_smbconfig) != NULL)
		{
            buf[strlen(buf) - 1] = 0;
            strcpy(smbaccess, buf);
        }
        fclose(fp_smbconfig);

		#if 0
		printf("smbheader %s \n", smbheader);
        printf("smbnameis %s \n", smbname);
        printf("smbpath %s \n", smbpath);
        printf("smbshare %s \n", smbshare);
        printf("smbaccess %s \n", smbaccess);
		#endif
		
        // 2222 : According to smb_config to share dir automaticlly
        sprintf(cmd_str, "/usr/script/samba_add_dir.sh %s %s %s %s %s", smbname, smbpath, "admin", smbshare, smbaccess);
        //DBPRINT("cmd_str is %s\n", cmd_str);
        system(cmd_str);

		// init variable 
		memset(part, 0, sizeof(part));
		memset(path, 0, sizeof(path));
		memset(dev_type, 0, sizeof(dev_type));
    }
	
	if(fp_proc)
		fclose(fp_proc);

	//DBPRINT("%s %d Start samba\n",__FUNCTION__, __LINE__);
	system("/userfs/bin/smbd -D"); // need reboot
	sleep(1);
	system("/userfs/bin/nmbd -D");
    return 0;

}



static void StorageSubmit(asp_reent* reent, const asp_text* params,  asp_text* ret)
{
	char sharenum[10], accessnum[10], pathnum[10], volumenum[10];
    // not update
    //description0, type0, totalspace0, freespace0, id0
    char idnum[4];
    char descriptionnum[16], typenum[8], totalspacenum[16], freespacenum[16];
	
    char *tmppath, *tmpvolume, *tmpshare, *tmpaccess;
    char *tmpid;
    char *tmpdescription, *tmptype, *tmptotalspace, *tmpfreespace;


    FILE *fp_smbconfig = NULL;
    char smb_config_file[30];
    int totalcount, i = 0;

    FILE *fp_storage = NULL;
    char bufJson[256 * 16]; //need to refine these values
    char tmpJson[1024]; //need to refine these values
    int len;
	char *tmp;
    memset(&bufJson, 0, 4096);
    memset(&tmpJson, 0, 1024);
    
    // tmp columnum
    memset(pathnum, 0, sizeof(pathnum));
    memset(volumenum, 0, sizeof(volumenum));
    memset(sharenum, 0, sizeof(sharenum));
    memset(accessnum, 0, sizeof(accessnum));
    //not update
    memset(idnum, 0, sizeof (idnum));
    memset(descriptionnum, 0, sizeof(descriptionnum));
    memset(typenum, 0, sizeof(typenum));
    memset(totalspacenum, 0, sizeof(totalspacenum));
    memset(freespacenum, 0, sizeof(freespacenum));

	memset(smbheader, 0, sizeof(smbheader));

    fp_storage = fopen(STORAGE_INFO_FILE, "w+");
    if (NULL == fp_storage) {
        printf("open /var/storage_info.txt error");
        return -1;
    }

    // fetch from web input

	tmp = get_param(g_var_post,"totalcount");

	if(tmp)
		totalcount = atoi(tmp);

	 DBPRINT("<>totalcount is %d\n", totalcount);	
	//printf("totalcount form GUI storageSmbControl is %d\n",totalcount);
	
    strcpy(bufJson, "{devices:[");

	for (i = 0; i < totalcount; i++)
	{
        sprintf(pathnum, "path%d", i);
        sprintf(volumenum, "volume%d", i);
        sprintf(sharenum, "share%d", i);
        sprintf(accessnum, "access%d", i);
        // don't update part
        sprintf(idnum, "id%d", i);
        sprintf(descriptionnum, "description%d", i);
        sprintf(typenum, "type%d", i);
        sprintf(totalspacenum, "totalspace%d", i);
        sprintf(freespacenum, "freespace%d", i);

		
        tmppath = get_param(g_var_post,pathnum); 

		if(!tmppath)
			tmppath = "";

		decode_uri(tmppath);
		
        tmpvolume = get_param(g_var_post,volumenum);
		if(!tmpvolume)
			tmpvolume = "";

		decode_uri(tmpvolume);
		
        tmpshare = get_param(g_var_post,sharenum);
		if(!tmpshare)
			tmpshare = "";

		decode_uri(tmpshare);
        tmpaccess = get_param(g_var_post,accessnum);
		if(!tmpaccess)
			tmpaccess = "";
		
		decode_uri(tmpaccess);
        // don't update part
        tmpid = get_param(g_var_post,idnum);
		if(!tmpid)
			tmpid = "";
		decode_uri(tmpid);
        tmpdescription = get_param(g_var_post,descriptionnum);
		
		if(!tmpdescription)
			tmpdescription = "";
		
		decode_uri(tmpdescription);

        tmptype = get_param(g_var_post,typenum);

		if(!tmptype)
			tmptype = "";
		
		decode_uri(tmptype);
		
        tmptotalspace =  get_param(g_var_post,totalspacenum);
		if(!tmptotalspace)
			tmptotalspace = "";

		decode_uri(tmptotalspace);
        tmpfreespace = get_param(g_var_post,freespacenum);

		if(!tmpfreespace)
			tmpfreespace = "";
		decode_uri(tmpfreespace);
        /*1:
			//(Note 2) Update storage file   Jason ==> /var/storage_infor.txt:
			
                Sequence: Id + Path + volume + type + share + access
                                Description + totalspace + freesapce

                example: Id  + /media/sda1 + A + Fat(NTFS) + yes(no) + yes(no)
                                HuaWei + 3G + 1G
			*/
        //fprintf(fp_storage, "%s %s %s %s %s %s %s %s %s \n",
        //        tmpid, tmppath, tmpvolume, tmptype, tmpshare, tmpaccess,
        //        tmpdescription, tmptotalspace, tmpfreespace);
        sprintf(tmpJson, "{id:%s,path:'%s',volume:'%s',type:'%s',share:'%s',access:'%s',description:'%s',totalspace:'%s',freespace:'%s'},",
                tmpid, tmppath, tmpvolume, tmptype, tmpshare, tmpaccess, tmpdescription, tmptotalspace, tmpfreespace);
        strcat(bufJson, tmpJson);
		
		DBPRINT("<>tmpJson is %s\n", tmpJson);
		//(Note 2) End Update storage file   Jason ==> /var/storage_infor.txt:

		//(Note 1) Update every config file in /media/sda1, sda2, sda3 , sdb1
        //2: ==> open smb config file, then update

		strcpy(smbheader,"Aztech");
        sprintf(smb_config_file, "%s/smb_config", tmppath);
        DBPRINT("<>control smb_config is %s\n", smb_config_file);	
		

        fp_smbconfig = fopen(smb_config_file, "w+");
        if (NULL == fp_smbconfig)
		{
            //fprintf(stderr, "%s %d: open %s error\n", __FUNCTION__, __LINE__, smb_config_file);
			
			DBPRINT("<>Error opening is %s\n", smb_config_file);	
			fclose(fp_storage);
            return;
        }

        // pay attention '\n'
        fprintf(fp_smbconfig, "%s\n%s\n%s\n%s\n%s\n", smbheader, tmpvolume, tmppath, tmpshare, tmpaccess);
        fclose(fp_smbconfig);
		//(Note 1) End Update every config file in /media/sda1, sda2, sda3 , sdb1

        // memset for next loop
        // tmp columnum
        memset(pathnum, 0, sizeof(pathnum));
        memset(volumenum, 0, sizeof(volumenum));
        memset(sharenum, 0, sizeof(sharenum));
        memset(accessnum, 0, sizeof(accessnum));
        // not update
        memset(idnum, 0, sizeof(idnum));
        memset(descriptionnum, 0, sizeof(descriptionnum));
        memset(typenum, 0, sizeof(typenum));
        memset(totalspacenum, 0, sizeof(totalspacenum));
        memset(freespacenum, 0, sizeof(freespacenum));
		memset(smbheader, 0, sizeof(smbheader));
    }
	
    len = strlen(bufJson);
    if (len > 50)
    {
        bufJson[len - 1] = '\0';
    }
    strcat(bufJson, "]}");
    fprintf(fp_storage, bufJson);
    fclose(fp_storage);
    //launch samba server
    launchSambaSrv();
   
	sleep(3);
	asp_send_response (NULL, "{success:true}", 14);
	//debug print
}

static void SiteSurvey(asp_reent* reent, const asp_text* params,  asp_text* ret)
{
	//tcdbg_printf("SiteSurvey BOA called\n");
	char en[4];
	char html[1500];
	tcapi_get("WLan_Common","APOn",en);
	//tcdbg_printf("EN=%s\n",en);

	//need to check this else hang else when access advance mode page
	if(atoi(en)==0)
	{
		//tcdbg_printf("WL disable\n");
		memset(html,0,sizeof(html));
		asp_send_response (NULL,html,strlen(html));
		return;
	}

	//tcdbg_printf("WL enable\n");

	//static unsigned char setb4=0;
	//if(!setb4)
	{
		system("/userfs/bin/iwpriv ra0 set SiteSurvey=1");
		//setb4=1;
	}
	system("/userfs/bin/iwpriv ra0 get_site_survey > /tmp/sitesurvey.txt");
	//tcdbg_printf("WL disable\n");

	FILE *fp2=NULL;
	char buf[160];

	unsigned char nomoreignore=0;
	unsigned char nossiddetected=0;
		
	char i=0;

	if((fp2 = fopen("/tmp/sitesurvey.txt", "r"))!=NULL)
	{
		strcpy(html,"{ \"sitesurveys\" : [");
		char format_token[100];
		int j=0;

		while(fgets(buf,sizeof(buf),fp2))
		{
			if(!nomoreignore)
			{
				if(strstr(buf,"get_site_survey")!=NULL)
					continue;
				if(strstr(buf,"Ch")!=NULL)
				{
					nomoreignore=1;
					continue;
				}
			}
			//tcdbg_printf("buf length=%d\n",strlen(buf));
			if(strlen(buf)==1)
				break;

			int i=0;
			if(j++>0)
				strcat(html,",");

			strcat(html," [");

			char *tmp=strdup(buf);
			char *token=NULL;
			char ssid[64];

			token = strtok (tmp, " \t");

			nossiddetected=0;

			while(token!=NULL)
			{
				if(i==0 || i==1 || i==2 || i==3 || i ==4)
                {
                    //printf("i=%d token=%s\n",i,token);
					if(i==0)
					{
						sprintf(format_token,"\"%s\"",token);
						strcat(html,format_token);
					}
					else
					{
						if(i==1)
						{
							//NO SSID DETECTED
							if(strchr(token,':')!=NULL)
							{
								strcpy(format_token,",\" \"");
								strcat(html,format_token);
								nossiddetected=1;
							}
							else
								strcpy(ssid,token);
						}
						else if(i==2 && !nossiddetected)
						{
							for(;;)
							{
								if(strchr(token,':')!=NULL)
								{
									sprintf(format_token,",\"%s\"",ssid);
									strcat(html,format_token);
									break;
								}
								else
								{
									strcat(ssid," ");
									strcat(ssid,token);
									token = strtok(NULL," \t");
								}
							}
						}
						else
						{
							if(i==3 && nossiddetected || i == 4 && !nossiddetected)
							{
								sprintf(format_token,",\"%s\"",token);
								strcat(html,format_token);
							}
						}
					}
                }
                i++;

				token = strtok(NULL," \t");
			}
	
            free(tmp);
            strcat(html," ]");
            //tcdbg_printf("\n");
		}

		strcat(html," ] }");
		//tcdbg_printf("\n\n%s\n",html);
		//tcdbg_printf("%s\n",html);

		fclose(fp2);
		fp2=NULL;
	}

	asp_send_response (NULL,html,strlen(html));
}

static void EtherWanLine(void)
{
	char html[32] = {0};
	FILE *fp = NULL;
	
	system("cat /proc/tc3162/gsw_link_st | grep 'Port4 : ' > /tmp/etherstream");
	fp = fopen("/tmp/etherstream", "r+b");
	
	if( fp == NULL ){
		tcdbg_printf("open file error!!\n");
		return;
	}
	
	fscanf(fp,"Port4 : %s",html);
	fflush(fp);
	fclose(fp);

	if(strlen(html) == 0)
		strcpy(html, "N/A");
	else if(strcmp(html, "Down") != 0)
		strcpy(html, "Up");
	
	asp_send_response (NULL,html,strlen(html)); 
}
