#ifndef _LIB_TCAPI_H
#define _LIB_TCAPI_H
#ifdef TCSUPPORT_OMCI
#include "../../private/xpon/inc/omci/omci_external_msg.h"
#endif
int
tcapi_set(char* node, char* attr, char* value);

int
tcapi_unset(char* node);

int
tcapi_get(char* node, char* attr, char *retval);

int
tcapi_staticGet(char* node, char* attr, char *retval);

int
tcapi_show(char* node, char * retval);

int
tcapi_commit(char* node);

int
tcapi_save(void);
int
tcapi_read(char* node);

int
tcapi_readAll(void);

void
tcdbg_printf(char *fmt,...);

/*TR069 message mechanism----------add by brian*/
#define PROJID 2
#define MAX_READ_SIZE 256
#define MAX_SEND_SIZE 256
#define CWMP_MQ_FLAG_PATH "/tmp/cwmp/tr069agent_mq"
#define CWMP_MAX_MSG_LEN 256

/*TR069 message mechanism---------add by brian*/
typedef struct cwmp_msg
{
	char cwmptype;
	union
	{
		char reserved[CWMP_MAX_MSG_LEN - 1];
	}text;
}cwmp_msg_t;

typedef struct tc_msg
{
	long mtype;
	cwmp_msg_t msgtext;//message content
}tc_msg_t;

int 
sendmegq(long type,cwmp_msg_t *buf,int flag);

#ifdef TCSUPPORT_OMCI
////////////////for OMCI////////////////
//#define OMCI_DEBUG
int sendOmciCmdMsg(char msgType, omciBaselinePayload_t *buf);
int sendOmciMeCmdMsg(omciBaselinePayload_t *buf);
int sendOmciNotifyMsg( notify_msg_t *buf);



#endif//#ifndef _OMCI_TYPES_H_

#ifdef TCSUPPORT_EPON_OAM_CTC
typedef struct oamAlarmMsg_s
{
	long msg_type;

	unsigned short  trapIndex;			// Alarm ID
	unsigned short  devIndex_1;			// port ID
	unsigned short  devIndex_2;			// LLID
	unsigned short  devIndex_3;			// PON IF
	unsigned char   trapOtherInfo[100];	// Alarm State & Info
}OamAlarmMsg_t, *OamAlarmMsg_Ptr;

int sendAlarm2EponOam(OamAlarmMsg_Ptr pAlarm);
#endif

#endif
